%bcond_without gui

Summary:  Very high compression ratio file archiver
Name:     p7zip
Version:  16.02
Release:  1%{?dist}
License:  LGPLv2 and (LGPLv2+ or CPL)
URL:      http://p7zip.sourceforge.net/
Source:    https://sourceforge.net/projects/p7zip/files/p7zip/%{version}/p7zip_%{version}_src_all.tar.bz2
Patch0000: p7zip_15.14-norar_cmake.patch
Patch0004: p7zip-manpages.patch
Patch0005: 02-man.patch
Patch0006: CVE-2016-9296.patch
Patch0007: 05-hardening-flags.patch
Patch0010: CVE-2017-17969.patch
Patch0011: 14-Fix-g++-warning.patch
Patch0012: gcc10-conversion.patch
Patch0013: 0001-fix-data-null-pointer.patch
Patch0014: 0001-fix-out-of-mem.patch

BuildRequires: make, gcc, gcc-c++, cmake
%ifarch x86_64
BuildRequires: yasm
%endif

%description
p7zip is a port of 7za.exe for Unix. 7-Zip is a file archiver with a very high
compression ratio. The original version can be found at http://www.7-zip.org/.

%package plugins
Summary: Additional plugins for p7zip

%description plugins
Additional plugins that can be used with 7z to extend its abilities.
This package contains also a virtual file system for Midnight Commander.

%package        doc
Summary:        Manual documentation and contrib directory
BuildArch:      noarch

%description    doc
This package contains the p7zip manual documentation and some code
contributions.

%prep
%autosetup -p1 -n %{name}_%{version}
rm -rf CPP/7zip/{Archive,Compress,Crypto,QMAKE}/Rar*
rm /DOC/unRarLicense.txt
mv DOC/License.txt DOC/copying.txt .

%build
pushd CPP/7zip/CMAKE/
sh ./generate.sh
popd
%ifarch x86_64
cp -f makefile.linux_amd64_asm makefile.machine
%endif

%make_build all2 \
    OPTFLAGS="%{optflags}" \
    DEST_HOME=%{_prefix} \
    DEST_BIN=%{_bindir} \
    DEST_SHARE=%{_libexecdir}/p7zip \
    DEST_MAN=%{_mandir}


%install
make install \
    DEST_DIR=%{buildroot} \
    DEST_HOME=%{_prefix} \
    DEST_BIN=%{_bindir} \
    DEST_SHARE=%{_libexecdir}/p7zip \
    DEST_MAN=%{_mandir}

mv %{buildroot}%{_docdir}/p7zip/DOC/* %{buildroot}%{_docdir}/p7zip
rmdir %{buildroot}%{_docdir}/p7zip/DOC/


%check
make test

%files
%license copying.txt License.txt
%{_docdir}/p7zip
%exclude  %{_docdir}/p7zip/MANUAL
%{_bindir}/7za
%dir %{_libexecdir}/p7zip/
%{_libexecdir}/p7zip/7za
%{_libexecdir}/p7zip/7zCon.sfx
%{_mandir}/man1/7za.1*
%exclude %{_mandir}/man1/7zr.1*

%files plugins
%{_bindir}/7z
%dir %{_libexecdir}/p7zip/
%{_libexecdir}/p7zip/7z
%{_libexecdir}/p7zip/7z.so
%{_mandir}/man1/7z.1*

%files doc
%doc contrib/
%{_docdir}/p7zip/MANUAL


%changelog
* Mon Dec 25 2023 Chair <chairou@tencent.com> - 16.02-1
- Init
